<?php
/*
+ ----------------------------------------------------------------------------+
|     e107 website system
|
|     ©Steve Dunstan 2001-2002
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     PhpFreeChat plugin v1.6: Config
|
|     $URL: svn://bigtux/dummy_radio/trunk/e107_plugins/phpfreechat_menu/config.php $
|     $Revision: 52 $
|     $Date: 2008-02-02 16:08:10 +0100 (Sa, 02 Feb 2008) $
|     $Author: matthias $
+----------------------------------------------------------------------------+
*/

require_once dirname(__FILE__)."/src/pfcglobalconfig.class.php";
require_once("../../class2.php");

$lan_file = e_PLUGIN."phpfreechat_menu/languages/".e_LANGUAGE.".php";
include_lan($lan_file);

function createRandomPassword() {
  $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
  srand((double)microtime() * 1000000);
  $i = 0;
  $pass = '' ;
  while ($i <= 7) {
    $num = rand() % 62;
    $tmp = substr($chars, $num, 1);
    $pass = $pass . $tmp;
    $i++;
  }
  return $pass;
}

$params = array();

if (IsSet($pref['phpfreechat_caption']) && $pref['phpfreechat_caption'] != "") {
  $params["title"] = $pref['phpfreechat_caption'];
} else {
  $params["title"] = "My Chat";
}
$params["serverid"] = md5($params["title"]);
 
if (IsSet($pref['phpfreechat_output_encoding']) && $pref['phpfreechat_output_encoding'] == "1") {
  $params["output_encoding"] = "ISO-8859-1";
}

if ($pref['user_tracking'] == "session") {
  $sessionname = session_name();
  if (!IsSet($sessionname) && $sessionname != "phpfreechat") {
    $params["nick"] = $pref['phpfreechat_nick'].rand(1, 100);
  } else {
    if (!IsSet($_COOKIE['e107_phpfreechatTime']) && $_COOKIE['e107_phpfreechatTime'] == "") {
      setcookie("e107_phpfreechatTime", "".rand(1, 100)."");
      $_COOKIE['e107_phpfreechatTime'] = "".rand(1, 100)."";
    }
     
  }
} else {
  if (!IsSet($_COOKIE['e107_phpfreechatTime']) && $_COOKIE['e107_phpfreechatTime'] == "") {
    setcookie("e107_phpfreechatTime", "".rand(1, 100)."");
    $_COOKIE['e107_phpfreechatTime'] = "".rand(1, 100)."";
  }
}

function age($dob) {
  // should accept anything and return years of age
  if ($tm = strtotime($dob)) {
    $ydiff = date("Y") - date("Y", $tm);
    $mdiff = date("m") - date("m", $tm);
    $ddiff = date("d") - date("d", $tm);
    if ($mdiff < 0) {
      $ydiff--;
    } elseif (($mdiff==0) && ($ddiff < 0)) {
       $ydiff--;
    }
    return $ydiff;
  } else {
    return '?';
  }
}

// Let e107 do the dirty work of finding the correct avatars
require_once(e_HANDLER."avatar_handler.php");

if (!USER) {
  if (IsSet($pref['phpfreechat_nick']) && $pref['phpfreechat_nick'] != "") {
    $params["nick"] = $pref['phpfreechat_nick'].$_COOKIE['e107_phpfreechatTime'];
  } else {
    $params["nick"] = PHPFREECHAT_LAN_26.$_COOKIE['e107_phpfreechatTime'];
  }
  // visible to anyone
  // use random avatar from e107's e107_images/avatars folder
  // these should be called "avatar_guest_1.gif" .. "avatar_guest_9.gif"
  $params["nickmeta"] = array("avatar" => avatar("avatar_guest_".rand(1, 9).".jpg"));
} else {
  // registered user
  if (IsSet($pref['phpfreechat_nick']) && $pref['phpfreechat_nick'] != "") {
    $params["nick"] = $pref['phpfreechat_nick'].$_COOKIE['e107_phpfreechatTime'];
  } else {
    $params["nick"] = USERNAME;
  }
  // Some Meta Info about the user (standard fields)
  if (defset('USERIMAGE')) $params["nickmeta"]["avatar"] = avatar(USERIMAGE);
  if (defset('USEREMAIL')) $params["nickmeta"]["email"] = USEREMAIL;

  // User Extended fields, may not be present in YOUR installation
  // (Which will not harm anything.)
  if ($user = get_user_data(USERID)) {
    // gender: 0=unknown, 1=female, 2=male, 3=couple
    if (varset($user['user_gender'])) $params["nickmeta"]["gender"] = $user['user_gender'];
    // date of birth in any strtotime() compatible format, age will be calculated
    if (varset($user['user_birthday'])) $params["nickmeta"]["birthday"] = $user['user_birthday'];
    if (varset($user['user_birthday'])) $params["nickmeta"]["age"] = age($user['user_birthday']);
    // the language the user has currently selected in e107
    if (varset($user['user_language'])) $params["nickmeta"]["language"] = $user['user_language'];
    // the country the user lives in (2-letter ISO format)
    if (varset($user['user_country'])) {
      $params["nickmeta"]["country"] = $user['user_country'];
      // all flag images (.gif, 16x11px) should be in e107_images/flags/
      $fname = 'flags/'.strtolower($user['user_country']).'.gif';
      // check filesystem but generate absolute URL for chat
      if (is_readable(e_IMAGE.$fname)) {
        $params["nickmeta"]["flag"] = e_IMAGE_ABS.$fname;
      }
    }
  }
  
  // Now which of the above should only be visible to chat admins?
  $params["nickmeta_private"] = array('ip', 'email', 'birthday');
}
 
if (IsSet($pref['phpfreechat_timeout']) && $pref['phpfreechat_timeout'] != "") {
  settype($pref['phpfreechat_timeout'], "integer");
  $params["timeout"] = $pref['phpfreechat_timeout'];
}
 
 
if (check_class($pref['phpfreechat_frozen_nick_class']) ) {
  $params["frozen_nick"] = true;
} else {
  $params["frozen_nick"] = false;
}
 
if (check_class($pref['phpfreechat_admin_class']) ) {
  $params["isadmin"] = true;
} else {
  $params["isadmin"] = false;
}
 
if (IsSet($pref['phpfreechat_password']) && $pref['phpfreechat_password'] != "") {
  $params['admins'] = array('admin' => $pref['phpfreechat_password']);
} else {
  $password = createRandomPassword();
  $params['admins'] = array('admin' => $password);
}
 
if (IsSet($pref['phpfreechat_mysql']) && $pref['phpfreechat_mysql'] == "1") {
  $params["container_type"] = "mysql";
  if (IsSet($pref['phpfreechat_mysql_host']) && $pref['phpfreechat_mysql_host'] != "") {
    $params["container_cfg_mysql_host"] = $pref['phpfreechat_mysql_host'];
  } else {
    $params["container_cfg_mysql_host"] = $mySQLserver;
  }
   
  if (IsSet($pref['phpfreechat_mysql_port']) && $pref['phpfreechat_mysql_port'] != "") {
    $params["container_cfg_mysql_port"] = $pref['phpfreechat_mysql_port'];
  } else {
    $params["container_cfg_mysql_port"] = 3306;
  }
   
  if (IsSet($pref['phpfreechat_mysql_database']) && $pref['phpfreechat_mysql_database'] != "") {
    $params["container_cfg_mysql_database"] = $pref['phpfreechat_mysql_database'];
  } else {
    $params["container_cfg_mysql_database"] = $mySQLdefaultdb;
  }
   
  if (IsSet($pref['phpfreechat_mysql_table']) && $pref['phpfreechat_mysql_table'] != "") {
    $params["container_cfg_mysql_table"] = $pref['phpfreechat_mysql_table'];
  } else {
    $params["container_cfg_mysql_table"] = $mySQLprefix."phpfreechat";
  }
   
  if (IsSet($pref['phpfreechat_mysql_username']) && $pref['phpfreechat_mysql_username'] != "") {
    $params["container_cfg_mysql_username"] = $pref['phpfreechat_mysql_username'];
  } else {
    $params["container_cfg_mysql_username"] = $mySQLuser;
  }
   
  if (IsSet($pref['phpfreechat_mysql_password']) && $pref['phpfreechat_mysql_password'] != "") {
    $params["container_cfg_mysql_password"] = $pref['phpfreechat_mysql_password'];
  } else {
    $params["container_cfg_mysql_password"] = $mySQLpassword;
  }
   
} else {
  $params["container_type"] = "file";
} // MySQL or File Support
 
 
// Set chat language according to what's specified in the language file
$params["language"] = PHPFREECHAT_LAN_27;
 
if (IsSet($pref['phpfreechat_channels']) && $pref['phpfreechat_channels'] != "") {
  $chanarray = split(" " , $pref['phpfreechat_channels']);
  $params["channels"] = $chanarray;
}
if (IsSet($pref['phpfreechat_frozen_channels']) && $pref['phpfreechat_frozen_channels'] != "") {
  $frozenchanarray = split(" " , $pref['phpfreechat_frozen_channels']);
  $params["frozen_channels"] = $frozenchanarray;
}
 
if (IsSet($pref['phpfreechat_theme']) && $pref['phpfreechat_theme'] != "") {
  $params["theme"] = $pref['phpfreechat_theme'];
} else {
  $params["theme"] = "default";
}
 
if (IsSet($pref['phpfreechat_post_proxies']) && $pref['phpfreechat_post_proxies'] != "") {
  $proxiesarray = split(" " , $pref['phpfreechat_post_proxies']);
  $params["post_proxies"] = $proxiesarray;
}
 
if (IsSet($pref['phpfreechat_censor']) && $pref['phpfreechat_censor'] != "") {
  $censorarray = split(" " , $pref['phpfreechat_censor']);
  $params["proxies_cfg"]["censor"]["words"] = $censorarray;
}
 
if (IsSet($pref['phpfreechat_replaceby']) && $pref['phpfreechat_replaceby'] != "") {
  $params["proxies_cfg"]["censor"]["replaceby"] = $pref['phpfreechat_replaceby'];
}
 
if (IsSet($pref['phpfreechat_connect_at_startup']) && $pref['phpfreechat_connect_at_startup'] == "1") {
  $params["connect_at_startup"] = true;
} else {
  $params["connect_at_startup"] = false;
}
 
if (IsSet($pref['phpfreechat_quit_on_closedwindow']) && $pref['phpfreechat_quit_on_closedwindow'] == "1") {
  $params["quit_on_closedwindow"] = true;
} else {
  $params["quit_on_closedwindow"] = false;
}
 
if (IsSet($pref['phpfreechat_focus_on_connect']) && $pref['phpfreechat_focus_on_connect'] == "1") {
  $params["focus_on_connect"] = true;
} else {
  $params["focus_on_connect"] = false;
}
if (IsSet($pref['phpfreechat_start_minimized']) && $pref['phpfreechat_start_minimized'] == "1") {
  $params["start_minimized"] = true;
} else {
  $params["start_minimized"] = false;
}
if (IsSet($pref['phpfreechat_startwithsound']) && $pref['phpfreechat_startwithsound'] == "1") {
  $params["startwithsound"] = true;
} else {
  $params["startwithsound"] = false;
}
if (IsSet($pref['phpfreechat_openlinknewwindow']) && $pref['phpfreechat_openlinknewwindow'] == "1") {
  $params["openlinknewwindow"] = true;
} else {
  $params["openlinknewwindow"] = false;
}
if (IsSet($pref['phpfreechat_notify_window']) && $pref['phpfreechat_notify_window'] == "1") {
  $params["notify_window"] = true;
} else {
  $params["notify_window"] = false;
}
if (IsSet($pref['phpfreechat_short_url']) && $pref['phpfreechat_short_url'] == "1") {
  $params["short_url"] = true;
} else {
  $params["short_url"] = false;
}
if (IsSet($pref['phpfreechat_short_url_width']) && $pref['phpfreechat_short_url_width'] != "") {
  settype($pref['phpfreechat_short_url_width'], "integer");
  $params["short_url_width"] = $pref['phpfreechat_short_url_width'];
}
if (IsSet($pref['phpfreechat_lockurl']) && $pref['phpfreechat_lockurl'] != "") {
   
  $params["lockurl"] = $pref['phpfreechat_lockurl'];
}
 
if (IsSet($pref['phpfreechat_noflood_charlimit']) && $pref['phpfreechat_noflood_charlimit'] != "") {
  $params["proxies_cfg"]["noflood"]["charlimit"] = $pref['phpfreechat_noflood_charlimit'];
}
if (IsSet($pref['phpfreechat_noflood_msglimit']) && $pref['phpfreechat_noflood_msglimit'] != "") {
   
  $params["proxies_cfg"]["noflood"]["msglimit"] = $pref['phpfreechat_noflood_msglimit'];
}
if (IsSet($pref['phpfreechat_noflood_delay']) && $pref['phpfreechat_noflood_delay'] != "") {
   
  $params["proxies_cfg"]["noflood"]["delay"] = $pref['phpfreechat_noflood_delay'];
}
 
if (IsSet($pref['phpfreechat_nickmarker']) && $pref['phpfreechat_nickmarker'] == "1") {
  $params["nickmarker"] = true;
} else {
  $params["nickmarker"] = false;
}
if (IsSet($pref['phpfreechat_clock']) && $pref['phpfreechat_clock'] == "1") {
  $params["clock"] = true;
} else {
  $params["clock"] = false;
}
if (IsSet($pref['phpfreechat_display_ping']) && $pref['phpfreechat_display_ping'] == "1") {
  $params["display_ping"] = true;
} else {
  $params["display_ping"] = false;
}
if (IsSet($pref['phpfreechat_display_pfc_logo']) && $pref['phpfreechat_display_pfc_logo'] == "1") {
  $params["display_pfc_logo"] = true;
} else {
  $params["display_pfc_logo"] = false;
}
if (IsSet($pref['phpfreechat_displaytabimage']) && $pref['phpfreechat_displaytabimage'] == "1") {
  $params["displaytabimage"] = true;
} else {
  $params["displaytabimage"] = false;
}
if (IsSet($pref['phpfreechat_displaytabclosebutton']) && $pref['phpfreechat_displaytabclosebutton'] == "1") {
  $params["displaytabclosebutton"] = true;
} else {
  $params["displaytabclosebutton"] = false;
}
if (IsSet($pref['phpfreechat_showwhosonline']) && $pref['phpfreechat_showwhosonline'] == "1") {
  $params["showwhosonline"] = true;
} else {
  $params["showwhosonline"] = false;
}
if (IsSet($pref['phpfreechat_showsmileys']) && $pref['phpfreechat_showsmileys'] == "1") {
  $params["showsmileys"] = true;
} else {
  $params["showsmileys"] = false;
}
if (IsSet($pref['phpfreechat_btn_sh_whosonline']) && $pref['phpfreechat_btn_sh_whosonline'] == "1") {
  $params["btn_sh_whosonline"] = true;
} else {
  $params["btn_sh_whosonline"] = false;
}
if (IsSet($pref['phpfreechat_btn_sh_smileys']) && $pref['phpfreechat_btn_sh_smileys'] == "1") {
  $params["btn_sh_smileys"] = true;
} else {
  $params["btn_sh_smileys"] = false;
}
 
if (IsSet($pref['phpfreechat_shownotice']) && $pref['phpfreechat_shownotice'] != "") {
  settype($pref['phpfreechat_shownotice'], "integer");
  $params["shownotice"] = $pref['phpfreechat_shownotice'];
}
if (IsSet($pref['phpfreechat_max_nick_len']) && $pref['phpfreechat_max_nick_len'] != "") {
  settype($pref['phpfreechat_max_nick_len'], "integer");
  $params["max_nick_len"] = $pref['phpfreechat_max_nick_len'];
}
if (IsSet($pref['phpfreechat_max_text_len']) && $pref['phpfreechat_max_text_len'] != "") {
  settype($pref['phpfreechat_max_text_len'], "integer");
  $params["max_text_len"] = $pref['phpfreechat_max_text_len'];
}
if (IsSet($pref['phpfreechat_max_channels']) && $pref['phpfreechat_max_channels'] != "") {
  settype($pref['phpfreechat_max_channels'], "integer");
  $params["max_channels"] = $pref['phpfreechat_max_channels'];
}
if (IsSet($pref['phpfreechat_max_privmsg']) && $pref['phpfreechat_max_privmsg'] != "") {
  settype($pref['phpfreechat_max_privmsg'], "integer");
  $params["max_privmsg"] = $pref['phpfreechat_max_privmsg'];
}
if (IsSet($pref['phpfreechat_refresh_delay']) && $pref['phpfreechat_refresh_delay'] != "") {
  settype($pref['phpfreechat_refresh_delay'], "integer");
  $params["refresh_delay"] = $pref['phpfreechat_refresh_delay'];
}
if (IsSet($pref['phpfreechat_height']) && $pref['phpfreechat_height'] != "") {
  $params["height"] = $pref['phpfreechat_height']."px";
}
if (IsSet($pref['phpfreechat_max_msg']) && $pref['phpfreechat_max_msg'] != "") {
  settype($pref['phpfreechat_max_msg'], "integer");
  $params["max_msg"] = $pref['phpfreechat_max_msg'];
}
 
if (IsSet($pref['phpfreechat_max_displayed_lines']) && $pref['phpfreechat_max_displayed_lines'] != "") {
  settype($pref['phpfreechat_max_displayed_lines'], "integer");
  $params["max_displayed_lines"] = $pref['phpfreechat_max_displayed_lines'];
}
 
if (IsSet($pref['phpfreechat_skip_proxies']) && $pref['phpfreechat_skip_proxies'] != "") {
  $skipproxiesarray = split(" " , $pref['phpfreechat_skip_proxies']);
  $params["skip_proxies"] = $skipproxiesarray;
}
if (IsSet($pref['phpfreechat_pre_proxies']) && $pref['phpfreechat_pre_proxies'] != "") {
  $preproxiesarray = split(" " , $pref['phpfreechat_pre_proxies']);
  $params["pre_proxies"] = $preproxiesarray;
}
if (IsSet($pref['phpfreechat_time_offset']) && $pref['phpfreechat_time_offset'] == "1") {
  $params["time_offset"] = true;
} else {
  $params["time_offset"] = false;
}
if (IsSet($pref['phpfreechat_date_format']) && $pref['phpfreechat_date_format'] != "") {
  $params["date_format"] = $pref['phpfreechat_date_format'];
}
 
if (IsSet($pref['phpfreechat_time_format']) && $pref['phpfreechat_time_format'] != "") {
  $params["time_format"] = $pref['phpfreechat_time_format'];
}
 
if (IsSet($pref['phpfreechat_islocked']) && $pref['phpfreechat_islocked'] == "1") {
  $params["islocked"] = true;
} else {
  $params["islocked"] = false;
}
 
if (IsSet($pref['phpfreechat_get_ip_from_xforwardedfor']) && $pref['phpfreechat_get_ip_from_xforwardedfor'] == "1") {
  $params["get_ip_from_xforwardedfor"] = true;
} else {
  $params["get_ip_from_xforwardedfor"] = false;
}
 
if (check_class($pref['phpfreechat_debug_class']) ) {
  $params["debug"] = true;
} else {
  $params["debug"] = false;
}
 
if (IsSet($pref['phpfreechat_bbcode_colorlist']) && $pref['phpfreechat_bbcode_colorlist'] != "") {
  $bbcodecolorlistarray = split(" " , $pref['phpfreechat_bbcode_colorlist']);
  $params["bbcode_colorlist"] = $bbcodecolorlistarray;
}
if (IsSet($pref['phpfreechat_nickname_colorlist']) && $pref['phpfreechat_nickname_colorlist'] != "") {
  $nicknamecolorlistarray = split(" " , $pref['phpfreechat_nickname_colorlist']);
  $params["nickname_colorlist"] = $nicknamecolorlistarray;
}
if (IsSet($pref['phpfreechat_theme_path']) && $pref['phpfreechat_theme_path'] != "") {
  $params["theme_path"] = $pref['phpfreechat_theme_path'];
}
if (IsSet($pref['phpfreechat_theme_url']) && $pref['phpfreechat_theme_url'] != "") {
  $params["theme_url"] = $pref['phpfreechat_theme_url'];
}
if (IsSet($pref['phpfreechat_theme_default_path']) && $pref['phpfreechat_theme_default_path'] != "") {
  $params["theme_default_path"] = $pref['phpfreechat_theme_default_path'];
}
if (IsSet($pref['phpfreechat_theme_default_url']) && $pref['phpfreechat_theme_default_url'] != "") {
  $params["theme_default_url"] = $pref['phpfreechat_theme_default_url'];
}
if (IsSet($pref['phpfreechat_server_script_path']) && $pref['phpfreechat_server_script_path'] != "") {
  $params["server_script_path"] = $pref['phpfreechat_server_script_path'];
}
if (IsSet($pref['phpfreechat_server_script_url']) && $pref['phpfreechat_server_script_url'] != "") {
  $params["server_script_url"] = $pref['phpfreechat_server_script_url'];
}
if (IsSet($pref['phpfreechat_client_script_path']) && $pref['phpfreechat_client_script_path'] != "") {
  $params["client_script_path"] = $pref['phpfreechat_client_script_path'];
}
if (IsSet($pref['phpfreechat_data_private_path']) && $pref['phpfreechat_data_private_path'] != "") {
  $params["data_private_path"] = $pref['phpfreechat_data_private_path'];
}
if (IsSet($pref['phpfreechat_data_public_path']) && $pref['phpfreechat_data_public_path'] != "") {
  $params["data_public_path"] = $pref['phpfreechat_data_public_path'];
}
if (IsSet($pref['phpfreechat_data_public_url']) && $pref['phpfreechat_data_public_url'] != "") {
  $params["data_public_url"] = $pref['phpfreechat_data_public_url'];
}
if (IsSet($pref['phpfreechat_prototypejs_url']) && $pref['phpfreechat_prototypejs_url'] != "") {
  $params["prototypejs_url"] = $pref['phpfreechat_prototypejs_url'];
}
if (IsSet($pref['phpfreechat_proxies_path']) && $pref['phpfreechat_proxies_path'] != "") {
  $params["proxies_path"] = $pref['phpfreechat_proxies_path'];
}
if (IsSet($pref['phpfreechat_path_default']) && $pref['phpfreechat_path_default'] != "") {
  $params["proxies_path_default"] = $pref['phpfreechat_path_default'];
}
if (IsSet($pref['phpfreechat_cmd_path']) && $pref['phpfreechat_cmd_path'] != "") {
  $params["cmd_path"] = $pref['phpfreechat_cmd_path'];
}
if (IsSet($pref['phpfreechat_cmd_path_default']) && $pref['phpfreechat_cmd_path_default'] != "") {
  $params["cmd_path_default"] = $pref['phpfreechat_cmd_path_default'];
}
 
?>