<?php
/*
+ ----------------------------------------------------------------------------+
|     e107 website system
|
|     ©Steve Dunstan 2001-2002
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     PhpFreeChat plugin v1.6: Plugin
|
|     $URL: svn://bigtux/dummy_radio/trunk/e107_plugins/phpfreechat_menu/plugin.php $
|     $Revision: 53 $
|     $Date: 2008-02-02 16:59:41 +0100 (Sa, 02 Feb 2008) $
|     $Author: matthias $
+----------------------------------------------------------------------------+
*/

include_lan(e_PLUGIN . "phpfreechat_menu/languages/" . e_LANGUAGE . ".php");

// Plugin info -------------------------------------------------------------------------------------------------------
$eplug_name = "PHPFreeChat Plugin";
$eplug_version = "1.6.2";
$eplug_author = "eaonflux, Moonbase";
$eplug_logo = "icon_32.png";
$eplug_url = "http://www.zwartemarkt.org/";
$eplug_email = "eaonflux@zwartemarkt.org";
$eplug_description = "Integration plugin for PHPFreeChat 1.0-final rev 1222";
$eplug_compatible = "e107v0.7+";
$eplug_readme = "admin_readme.php";	// leave blank if no readme file


// Name of the plugin's folder -------------------------------------------------------------------------------------
$eplug_folder = "phpfreechat_menu";

// Name of menu item for plugin ----------------------------------------------------------------------------------
$eplug_menu_name = "PHPFreeChat";

// Name of the admin configuration file --------------------------------------------------------------------------
$eplug_conffile = "admin_config.php";

// Icon image and caption text ------------------------------------------------------------------------------------
$eplug_icon = $eplug_folder."/images/icon_32.png";
$eplug_caption =  "PHPFreeChat Plugin Configuration";

// List of preferences -----------------------------------------------------------------------------------------------
// ------- Preferences --------------------------------------------+
  $eplug_prefs = array(
  "phpfreechat_caption" => "PHPFreeChat",
  "phpfreechat_language" => "en_US",
  "phpfreechat_password" => "",
  "phpfreechat_nickmarker" => 0,
  "phpfreechat_output_encoding" => 0,
  "phpfreechat_nick" => "",
  "phpfreechat_frozen_nick_class" => 255,
  "phpfreechat_nickname_colorlist" => "",
  "phpfreechat_channels" => "",
  "phpfreechat_frozen_channels" => "",
  "phpfreechat_theme" => "default",
  "phpfreechat_fullacces_class" => 255,
  "phpfreechat_admin_class" => 255,
  "phpfreechat_refresh_delay" => "",
  "phpfreechat_refresh_timeout" => "",
  "phpfreechat_height" => "",
  "phpfreechat_bbcode_colorlist" => "",
  "phpfreechat_mysql" => 0,
  "phpfreechat_mysql_host" => "",
  "phpfreechat_mysql_port" => "",
  "phpfreechat_mysql_database" => "",
  "phpfreechat_mysql_table" => "",
  "phpfreechat_mysql_username" => "",
  "phpfreechat_mysql_password" => "",
  "phpfreechat_clock" => "",
  "phpfreechat_display_ping" => "",
  "phpfreechat_display_pfc_logo" => 1,
  "phpfreechat_displaytabimage" => 1,
  "phpfreechat_displaytabclosebutton" => 1,
  "phpfreechat_showwhosonline" => 1,
  "phpfreechat_showsmileys" => 1,
  "phpfreechat_btn_sh_whosonline" => 1,
  "phpfreechat_btn_sh_smileys" => 1,
  "phpfreechat_get_ip_from_xforwardedfor" => 1,
  "phpfreechat_connect_at_startup" => 1,
  "phpfreechat_quit_on_closedwindow" => 1,
  "phpfreechat_focus_on_connect" => 0,
  "phpfreechat_start_minimized" => 0,
  "phpfreechat_startwithsound" => 1,
  "phpfreechat_openlinknewwindow" => 1,
  "phpfreechat_notify_window" => 1,
  "phpfreechat_shownotice" => 0,
  "phpfreechat_skip_proxies" => "",
  "phpfreechat_pre_proxies" => "",
  "phpfreechat_post_proxies" => "",
  "phpfreechat_noflood_charlimit" => "",
  "phpfreechat_noflood_msglimit" => "",
  "phpfreechat_noflood_delay" => "",
  "phpfreechat_max_nick_len" => "",
  "phpfreechat_max_text_len" => "",
  "phpfreechat_max_channels" => "",
  "phpfreechat_max_privmsg" => "",
  "phpfreechat_max_msg" => 10,
  "phpfreechat_max_displayed_lines" => "",
  "phpfreechat_censor" => "",
  "phpfreechat_replaceby" => "",
  "phpfreechat_islocked" => 0,
  "phpfreechat_short_url" => "",
  "phpfreechat_short_url_width" => "",
  "phpfreechat_lockurl" => "",
  "phpfreechat_debug_class" => 255,
  "phpfreechat_htmldebug_class" => 255,
  "phpfreechat_time_offset" => 0,
  "phpfreechat_date_format" => "",
  "phpfreechat_time_format" => "",
  "phpfreechat_theme_path" => "",
  "phpfreechat_theme_url" => "",
  "phpfreechat_theme_default_path" => "",
  "phpfreechat_theme_default_url" => "",
  "phpfreechat_server_script_path" => "",
  "phpfreechat_server_script_url" => "",
  "phpfreechat_client_script_path" => "",
  "phpfreechat_data_private_path" => "",
  "phpfreechat_data_public_path" => "",
  "phpfreechat_data_public_url" => "",
  "phpfreechat_prototypejs_url" => "",
  "phpfreechat_proxies_path" => "",
  "phpfreechat_proxies_path_default" => "",
  "phpfreechat_cmd_path" => "",
  "phpfreechat_cmd_path_default" => "",
  "phpfreechat_show_whois" => 1,
  "phpfreechat_show_last_msg" => 1,
  "phpfreechat_last_msg" => 5
  );

// List of table names -----------------------------------------------------------------------------------------------
$eplug_table_names = array(
	"phpfreechat"
);

// List of sql requests to create tables -----------------------------------------------------------------------------
$eplug_tables = array(
"CREATE TABLE ".MPREFIX."phpfreechat (
  `server` varchar(32) NOT NULL,
  `group` varchar(64) NOT NULL,
  `subgroup` varchar(128) NOT NULL,
  `leaf` varchar(128) NOT NULL,
  `leafvalue` text NOT NULL,
  `timestamp` int(11) NOT NULL,
  PRIMARY KEY  (`server`,`group`,`subgroup`,`leaf`),
  INDEX (`server`,`group`,`subgroup`,`timestamp`)
) ENGINE=MyISAM;");

// Create a link in main menu (yes=TRUE, no=FALSE) -------------------------------------------------------------
$eplug_link = TRUE;
$eplug_link_name = "Chat";
$eplug_link_url = e_PLUGIN."$eplug_folder/index.php";

// Text to display after plugin successfully installed ------------------------------------------------------------------
$eplug_done = "PHPFreeChat Plugin Successfully Installed!<br>Now Visit the Config Panel to Configure!";

// upgrading ... //

// $upgrade_add_prefs = ""; //

// $upgrade_remove_prefs = ""; //

// $upgrade_alter_tables = ""; //

// $eplug_upgrade_done = ""; //

?>
