<?php

require_once dirname(__FILE__)."/../pfci18n.class.php";
require_once dirname(__FILE__)."/../pfcuserconfig.class.php";
require_once dirname(__FILE__)."/../pfcproxycommand.class.php";

function scores_sort($a, $b) {
  if ($a == $b) return 0;
  return ($a > $b) ? -1 : 1;
}

if (!function_exists('scandir')) {
    function scandir($directory, $sorting_order = 0)
    {
        if (!is_string($directory)) {
            user_error('scandir() expects parameter 1 to be string, ' .
                gettype($directory) . ' given', E_USER_WARNING);
            return;
        }

        if (!is_int($sorting_order) && !is_bool($sorting_order)) {
            user_error('scandir() expects parameter 2 to be long, ' .
                gettype($sorting_order) . ' given', E_USER_WARNING);
            return;
        }

        if (!is_dir($directory) || (false === $fh = @opendir($directory))) {
            user_error('scandir() failed to open dir: Invalid argument', E_USER_WARNING);
            return false;
        }

        $files = array ();
        while (false !== ($filename = readdir($fh))) {
            $files[] = $filename;
        }

        closedir($fh);

        if ($sorting_order == 1) {
            rsort($files);
        } else {
            sort($files);
        }

        return $files;
    }
}

class pfcProxyCommand_quiz extends pfcProxyCommand {

	function run(&$xml_reponse, $p)	{

		$clientid    = $p["clientid"];
		$param       = $p["param"];
		$sender      = $p["sender"];
		$recipient   = $p["recipient"];
		$recipientid = $p["recipientid"];

		$c =& pfcGlobalConfig::Instance();
		$u =& pfcUserConfig::Instance();
		$ct =& pfcContainer::Instance();

		$cmdtocheck = array("send", "me");
		if (in_array($this->name, $cmdtocheck)) {

			$gotIt = array("{player} is correct!! Well done :D",
										 "{player} has got it this time.",
										 "{player} is a genius, he's got it!",
										 "Nice one {player}, that's it!",
										 "That's the one {player}! Well done :D");

			$closeEnough = array("Close enough {player}, I'll give you that one.",
													 "Yeah, that'll do {player}.",
													 "Go on {player}, I'm feeling generous.");

			$notCloseEnough = array("Close, but not quite close enough {player} :P",
															"Nearly there {player}",
															"No I'm not giving you that {player} :^)");

			$questions = unserialize($ct->getChanMeta($p["recipient"], 'questions'));
			$question = $ct->getChanMeta($p["recipient"], 'question');
			$scores = unserialize($ct->getChanMeta($p["recipient"], 'scores'));

			if (substr($param,0,1) == '@') {

				$cmd = explode(" ",substr($param,1));

				switch ($cmd[0]) {

					// Give some help
					case "help":
						$botspeak = "<b>Here are my commands:</b><br>";
						$botspeak .= "@init {set} - loads the specified question set<br>";
						$botspeak .= "@add {set} - adds the specified question set<br>";
						$botspeak .= "@listsets - lists all available question sets<br>";
						$botspeak .= "@ask - ask a question<br>";
						$botspeak .= "@hint - give a clue<br>";
						$botspeak .= "@scores - print the current scores<br>";
						$botspeak .= "@clearscores - clears the scores<br>";
						break;

					// Wake Quizbot
					case "start":
						break;

					// Initialise the question set
					case "init":
						if ($cmd[1] != "") {
							if (!include(dirname(__FILE__)."/questions/".$cmd[1].".questions.php")) {
								$botspeak = "Could not find question set: ".$cmd[1];
							} else {
								$questions = init_questions();
								if (count($questions) > 0) {
									$botspeak = "Question set loaded: ".$cmd[1];
								} else {
									$botspeak = "The question set appears to be empty :S Check ".$cmd[1].".questions.php";
								}
							}		
						} else {
							$botspeak = "No question set specified";
						}
						break;

					// Add a question set
					case "add":
						if ($cmd[1] != "") {
							if (!include(dirname(__FILE__)."/questions/".$cmd[1].".questions.php")) {
								$botspeak = "Could not find question set: ".$cmd[1];
							} else {
								$temp = init_questions();
								if (count($temp) > 0) {
									if (count($questions) > 0) {
										$questions = array_merge($questions,$temp);
									} else {
										$questions = $temp;
									}
									$botspeak = "Question set added: ".$cmd[1];
								} else {
									$botspeak = "The question set appears to be empty :S Check ".$cmd[1].".questions.php";
								}
							}		
						} else {
							$botspeak = "No question set specified";
						}
						break;

					// List the available question sets
					case "listsets":
						$botspeak = "<b>Installed question sets are:</b><br />";
						$files = scandir(dirname(__FILE__)."/questions");
						foreach ($files as $val) {
							if (stristr($val,".questions.php")) {
								$botspeak .= str_replace(".questions.php","",strtolower($val))."<br />";
							}
						}
						break;

					// Ask a question
					case "ask":
						if (count($questions) > 0) {
							$question = array_rand($questions);
							$botspeak = $question;
						} else {
							$botspeak = "I don't know any questions, use @init first";
						}
						break;

					// Show a hint
					case "hint":
						if (!$question) {
							$botspeak = "I've not asked a question ^o)";
						} else {
							$res = $questions[$question];
							for ($i = 1; $i < strlen($res); $i++ ) {
								$res[mt_rand(0,strlen($res)-1)] = "_";
							}
							$botspeak = $res;
						}
						break;

					// Print the current scores
					case "scores":
						if (count($scores) > 0) {
							$botspeak = "<b>The Scores Are:</b><br><table align='center' border='1px'><tr><th>Player</th><th>Score</th></td>";
							foreach ($scores as $key => $val) {
								$botspeak .= "<tr><td width='400px' align='center'>".$key."</td><td width='50px' align='center'>".$val."</td></tr>";
							}
							$botspeak .= "</table>";
						} else {
							$botspeak = "No scores have been set";
						}
						break;

					// Print the current scores
					case "clearscores":
						unset($scores);
						$botspeak = "Scores cleared";
						break;

					// Bot is confused!
					default:
						$botspeak = "Quizbot puzzled :S - ".$cmd[0];
						break;
				}

			} else {

				if (isset($question)) {

					// Init fuzzy compare
					$str1 = strtolower($param);
					$str2 = strtolower($questions[$question]);
					similar_text( $str1, $str2, $match);

					// How close?
					if ($match == 100) {
						$botspeak = str_replace("{player}",$sender,$gotIt[array_rand($gotIt)]);
					} elseif ($match >= 80) {
						$botspeak = str_replace("{player}",$sender,$closeEnough[array_rand($closeEnough)]);
					} elseif ($match >= 70) {
						$botspeak = str_replace("{player}",$sender,$notCloseEnough[array_rand($notCloseEnough)]);
					}

					// Got it right, add to scores
					if ($match >= 80) {
						$question = "";
						if (isset($scores[$sender])) {
							$scores[$sender] += 1;
						} else {
							if (count($scores) > 0) {
								$scores = array_merge($scores, array( $sender => 1 ));
							} else {
								$scores = array( $sender => 1 );
							}
						}
						uasort($scores,"scores_sort");
					}
				}
			}

			$ct->setChanMeta($p["recipient"], 'questions', serialize($questions));
			$ct->setChanMeta($p["recipient"], 'question', $question);
			$ct->setChanMeta($p["recipient"], 'scores', serialize($scores));

		}

		// forward the command to the next proxy or to the final command
		$p["clientid"]    = $clientid;
		$p["param"]       = $param;
		$p["sender"]      = $sender;
		$p["recipient"]   = $recipient;
		$p["recipientid"] = $recipientid;
		$ret = $this->next->run($xml_reponse, $p);

		if (isset($botspeak)) {
			$ct->write($recipient, "Quizbot", "send", $botspeak);
			unset($botspeak);
		}

		return $ret;

	}
}

?>