// customized NickItem and NickWhoisBox
// $Id: customize.js.php 52 2008-02-02 15:08:10Z matthias $
pfcClient.prototype.buildNickItem = function(nickid)
{
  var className = (! is_ie) ? 'class' : 'className';

  var nick = this.getUserMeta(nickid, 'nick');
  var isadmin = this.getUserMeta(nickid, 'isadmin');
  if (isadmin == '') isadmin = false;
  
  // get gender from e107: 0=unknown, 1=female, 2=male, 3=couple
  var gender = this.getUserMeta(nickid, 'gender');
  if (gender == '') gender = '0';

  var li = document.createElement('li');

  var a = document.createElement('a');
  a.setAttribute('href','#');
  a.pfc_nick   = nick;
  a.pfc_nickid = nickid;
  a.onclick = function(evt){
    var d = pfc.getNickWhoisBox(this.pfc_nickid);
    document.body.appendChild(d);
    d.style.display = 'block';
    d.style.zIndex = '400';
    d.style.position = 'absolute';
    d.style.left = (mousePosX(evt)-7)+'px';
    d.style.top  = (mousePosY(evt)-7)+'px';
    return false;
  }
  li.appendChild(a);

  var img = document.createElement('img');
  if (isadmin)
    img.setAttribute('src', this.res.getFileUrl('images/user-admin.gif'));
  else
    img.setAttribute('src', this.res.getFileUrl('images/user_gender_'+gender+'.gif'));
  img.style.marginRight = '5px';
  img.setAttribute(className, 'pfc_nickbutton');
  a.appendChild(img);

  // nobr is not xhtml valid but it's a workeround 
  // for IE which doesn't support 'white-space: pre' css rule
  var nobr = document.createElement('nobr');
  var span = document.createElement('span');
  span.setAttribute(className, 'pfc_nickmarker pfc_nick_'+nickid);
  span.innerHTML = nick.escapeHTML();
  nobr.appendChild(span);
  a.appendChild(nobr);

  return li;
}


pfcClient.prototype.updateNickWhoisBox = function(nickid)
{
    var className = (! is_ie) ? 'class' : 'className';

    var usermeta = this.getAllUserMeta(nickid);

    var div  = document.createElement('div');
    div.setAttribute(className, 'pfc_nickwhois');

    var p = document.createElement('p');
    p.setAttribute(className, 'pfc_nickwhois_header');
    div.appendChild(p);

    // add the close button
    var img = document.createElement('img');
    img.setAttribute(className, 'pfc_nickwhois_close');
    img.pfc_parent = div;
    img.onclick = function(evt){
      this.pfc_parent.style.display = 'none';
      return false;
    }
    img.setAttribute('src', this.res.getFileUrl('images/close-whoisbox.gif'));
    img.alt = this.res.getLabel('Close');
    p.appendChild(img);
    p.appendChild(document.createTextNode(usermeta.get('nick'))); // append the nickname text in the title

    // add the whois information table
    var table = document.createElement('table');
    var tbody = document.createElement('tbody');
    var um_keys = usermeta.keys();
    var msg = '';
    for (var i=0; i<um_keys.length; i++)
    {
      var k = um_keys[i];
      var v = usermeta.get(k);
      if (v && k != 'nickid'
            && k != 'nick' // useless because it is displayed in the box title
            && k != 'isadmin' // useless because of the gold shield icon
            && k != 'floodtime'
            && k != 'flood_nbmsg'
            && k != 'flood_nbchar'
            && k != 'avatar'
            // some extra user fields, will be gracefully ignored if non-existent
            && k != 'gender'
            && k != 'age'
            && k != 'country'
            && k != 'flag'
         )
      {
        var tr = document.createElement('tr');
        if (pfc_nickmeta_key_to_hide.indexOf(k) != -1)
        {
          var td2 = document.createElement('td');
          td2.setAttribute(className, 'pfc_nickwhois_c2');
          td2.setAttribute('colspan', 2);
          td2.innerHTML = v;
          tr.appendChild(td2);
        }
        else
        {
          var td1 = document.createElement('td');
          td1.setAttribute(className, 'pfc_nickwhois_c1');
          var td2 = document.createElement('td');
          td2.setAttribute(className, 'pfc_nickwhois_c2');
          td1.innerHTML = k;
          td2.innerHTML = v;
          tr.appendChild(td1);
          tr.appendChild(td2);
        }
        tbody.appendChild(tr);
      }
    }

    // append the avatar image
    if (this.getUserMeta(nickid,'avatar'))
    {
      var tr = document.createElement('tr');
      var td2 = document.createElement('td');
      td2.setAttribute(className, 'pfc_nickwhois_c2');
      td2.setAttribute('colspan', 2);
      var img = document.createElement('img');
      img.setAttribute('src',this.getUserMeta(nickid,'avatar'));
      img.setAttribute(className, 'pfc_nickwhois_avatar');
      td2.appendChild(img);
      tr.appendChild(td2);
      tbody.appendChild(tr);
    }
    
    // add gender symbol, age and country flag
    if (this.getUserMeta(nickid,'gender') || this.getUserMeta(nickid,'age') || this.getUserMeta(nickid,'flag'))
    {
      var tr = document.createElement('tr');
      var td2 = document.createElement('td');
      td2.setAttribute(className, 'pfc_nickwhois_c2');
      td2.setAttribute('colspan', 2);
      // Gender symbol
      if (gender = this.getUserMeta(nickid,'gender'))
      {
        if (gender == '') gender = '0';
        var img = document.createElement('img');
        // gender: 0=unknown, 1=female, 2=male, 3=couple
        img.setAttribute('src', this.res.getFileUrl('images/user_gender_'+gender+'.gif'));
        img.style.marginRight = '5px';
        td2.appendChild(img);
      }
      // Age in years
      if (age = this.getUserMeta(nickid,'age')) {
        td2.appendChild(document.createTextNode(age));
      }
      // Country flag
      if (flag = this.getUserMeta(nickid,'flag'))
      {
        if (flag != '')
        {
          var img = document.createElement('img');
          img.setAttribute('src', flag);
          if (country = this.getUserMeta(nickid,'country'))
          {
            img.setAttribute('alt', country);
            img.setAttribute('title', country);
          }
          img.style.marginLeft = '5px';
          td2.appendChild(img);
        }
      } else {
        // if no flag, try to display country name
        if (country = this.getUserMeta(nickid,'country')) {
          td2.appendChild(document.createTextNode(country));
        }
      }
      tr.appendChild(td2);
      tbody.appendChild(tr);
    }
    
    // add the privmsg link (do not add it if this button is yourself)
    if (pfc.getUserMeta(nickid,'nick') != this.nickname)
    {
      var tr = document.createElement('tr');
      var td2 = document.createElement('td');
      td2.setAttribute(className, 'pfc_nickwhois_c2');
      td2.setAttribute('colspan', 2);
      var a = document.createElement('a');
      a.setAttribute('href', '');
      a.pfc_nickid = nickid;
      a.pfc_parent = div;
      a.onclick = function(evt){
        var nick = pfc.getUserMeta(this.pfc_nickid,'nick');
        pfc.sendRequest('/privmsg "'+nick+'"');
        this.pfc_parent.style.display = 'none';
        return false;
      }
      var img = document.createElement('img');
      img.setAttribute('src', this.res.getFileUrl('images/openpv.gif'));
      img.alt = document.createTextNode(this.res.getLabel('Private message'));
      a.appendChild(img);
      a.appendChild(document.createTextNode(this.res.getLabel('Private message')));
      td2.appendChild(a);
      tr.appendChild(td2);
      tbody.appendChild(tr);
    }

    table.appendChild(tbody);
    div.appendChild(table);

    this.nickwhoisbox.set(nickid, div);  
}
